//
//  MyView.swift
//  Ex12CST
//
//  Created by 川上 博 on 2014/12/21.
//  Copyright (c) 2014年 Hiroshi Kawakami. All rights reserved.
//

import Cocoa

func caustic(bounds:NSRect, path:NSBezierPath) -> NSBezierPath{
    let INCPI=M_PI/71
    var u, t, r, x0, y0 : Double
    
    x0 = (Double)(bounds.size.width / 2.0)
    y0 = (Double)(bounds.size.height / 2.0)
    r = fmin(x0,y0) - 20.0
    
    for(t = M_PI/2.0 ; t < 1.5*M_PI; t += INCPI){
        u=3.0*t-M_PI;
        path.moveToPoint(NSMakePoint((CGFloat)(x0+r*cos(t)),(CGFloat)(y0+r*sin(t))))
        path.lineToPoint(NSMakePoint((CGFloat)(x0+r*cos(u)),(CGFloat)(y0+r*sin(u))))
    }
    return path
}


class MyView: NSView {
    override func drawRect(dirtyRect: NSRect) {
        NSColor.blueColor().setFill()
        NSRectFill(self.bounds)
        
        let path = NSBezierPath()
        
        NSColor.whiteColor().set()
        caustic(bounds, path: path)
        NSBezierPath.setDefaultLineWidth(1.0)
        path.stroke()
    }
}
